
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  clrDodgerBlue
#property indicator_width1  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int            DeMarkerPeriod   = 25;
extern ENUM_MA_METHOD DeMarkerMaMode   = MODE_SMA;
extern double         levelOb          = 0.7;
extern double         levelOs          = 0.3;
extern bool           alertsOn         = true;
extern bool           alertsOnCurrent  = true;
extern bool           alertsMessage    = true;
extern bool           alertsSound      = false;
extern bool           alertsEmail      = false;
extern bool           alertsNotify     = false;
extern string         soundFile        = "alert2.wav";
extern bool           ShowArrows       = true;
extern string         arrowsIdentifier = "Demark Arrows1";
extern double         arrowsUpperGap   = 1.0;
extern double         arrowsLowerGap   = 1.0;
extern color          arrowsUpColor    = clrLimeGreen;
extern color          arrowsDnColor    = clrRed;
extern int            arrowsUpCode     = 241;
extern int            arrowsDnCode     = 242;


//
//
//
//
//

double dem[];
double demH[];
double demL[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,dem); SetIndexLabel(0,"DeMarker");
   SetIndexBuffer(1,demH);
   SetIndexBuffer(2,demL);
   SetIndexBuffer(3,trend);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   IndicatorShortName("DeM("+DeMarkerPeriod+")");
return(0);
}

int deinit() 
{  
   deleteArrows(); 
return(0); 
}

//+------------------------------------------------------------------+
//| Cronex DeMarker                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int i,counted_bars = IndicatorCounted();
   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i = limit; i>=0; i--) 
   { 
      demH[i] = 0; if(High[i] > High[i+1]) demH[i] = High[i]  - High[i+1];
      demL[i] = 0; if(Low[i] < Low[i+1])   demL[i] = Low[i+1] - Low[i];
      double smtH = MathMax(iMAOnArray(demH,0,DeMarkerPeriod,0,DeMarkerMaMode,i),0);
      double smtL = MathMax(iMAOnArray(demL,0,DeMarkerPeriod,0,DeMarkerMaMode,i),0);
        if (smtH+smtL!=0)
               dem[i] = smtH/(smtH+smtL);
         else  dem[i] = 0;
         
         //
         //
         //
         //
         //
         
         trend[i] = 0;
           if (dem[i]>levelOb) trend[i] = 1;
           if (dem[i]<levelOs) trend[i] =-1; 
           
           //
           //
           //
           //
           //
           
           if (ShowArrows)
           {
             deleteArrow(Time[i]);
             if (trend[i]!=trend[i+1])
             {
               if (trend[i+1] ==  1 && trend[i] != 1) drawArrow(i,arrowsDnColor,arrowsDnCode,true);
               if (trend[i+1] == -1 && trend[i] !=-1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
             }
           } 
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar+1] ==  1 && trend[whichBar] != 1) doAlert(whichBar,"leaving overbought zone");
         if (trend[whichBar+1] == -1 && trend[whichBar] !=-1) doAlert(whichBar,"leaving oversold zone");
      }         
   }
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DeMarker ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Demarker "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}


//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}







